<?php
error_reporting(0);
require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/wp-load.php');
if (!is_user_logged_in() || !wp_verify_nonce($_GET['nonce'], 'ajax-nonce')) { die(); }

$url = esc_url_raw('http' . $_GET['url']);

if ($url != 'http://http') {
	$args = array(
		'user-agent' => 'Mozilla/5.0 (Windows NT 6.3; rv:36.0) Gecko/20100101 Firefox/36.0'
	);
	$response = wp_remote_get($url, $args);

	if(is_wp_error($response)) {
	   echo 'error' . $response->get_error_message();
	} else {
		preg_match("/content=\"text\/(.*)>/i", $response['body'], $content_type);

		if (strpos($response['headers']['content-type'], 'text/') !== false && ($response['response']['code'] == '200')) {
			preg_match("/<title>(.*?)<\/title>/is", $response['body'], $title);

			//for multiple languages in title ref: http://php.net/manual/en/function.htmlentities.php
			if (strpos($content_type[0], '8859-1') !== false) {
				$pinctitle = '<pinctitle>' . htmlentities($title[1], ENT_QUOTES, 'ISO-8859-1') . '</pinctitle>';
			} else if (strpos($content_type[0], '8859-5') !== false) {
				$pinctitle = '<pinctitle>' . htmlentities($title[1], ENT_QUOTES, 'ISO-8859-5') . '</pinctitle>';
			} else if (strpos($content_type[0], '8859-15') !== false) {
				$pinctitle = '<pinctitle>' . htmlentities($title[1], ENT_QUOTES, 'ISO-8859-15') . '</pinctitle>';
			} else if (strpos($content_type[0], '866') !== false) {
				$pinctitle = '<pinctitle>' . htmlentities($title[1], ENT_QUOTES, 'cp866') . '</pinctitle>';
			} else if (strpos($content_type[0], '1251') !== false) {
				$pinctitle = '<pinctitle>' . htmlentities($title[1], ENT_QUOTES, 'cp1251') . '</pinctitle>';
			} else if (strpos($content_type[0], '1252') !== false) {
				$pinctitle = '<pinctitle>' . htmlentities($title[1], ENT_QUOTES, 'cp1252') . '</pinctitle>';
			} else if (stripos($content_type[0], 'koi8') !== false) {
				$pinctitle = '<pinctitle>' . htmlentities($title[1], ENT_QUOTES, 'KOI8-R') . '</pinctitle>';
			} else if (stripos($content_type[0], 'hkscs') !== false) {
				$pinctitle = '<pinctitle>' . mb_convert_encoding($title[1], 'UTF-8', 'BIG5-HKSCS') . '</pinctitle>';
			} else if (stripos($content_type[0], 'big5') !== false || strpos($content_type[0], '950') !== false ) {
				$pinctitle = '<pinctitle>' . mb_convert_encoding($title[1], 'UTF-8', 'BIG5') . '</pinctitle>';
			} else if (strpos($content_type[0], '2312') !== false || strpos($content_type[0], '936') !== false ) {
				$pinctitle = '<pinctitle>' . mb_convert_encoding($title[1], 'UTF-8', 'GB2312') . '</pinctitle>';
			} else if (stripos($content_type[0], 'jis') !== false || strpos($content_type[0], '932') !== false ) {
				$pinctitle = '<pinctitle>' . mb_convert_encoding($title[1], 'UTF-8', 'Shift_JIS') . '</pinctitle>';
			} else if (stripos($content_type[0], 'jp') !== false) {
				$pinctitle = '<pinctitle>' . mb_convert_encoding($title[1], 'UTF-8', 'EUC-JP') . '</pinctitle>';
			} else {
				$pinctitle = '<pinctitle>' . htmlentities($title[1], ENT_QUOTES, 'UTF-8') . '</pinctitle>';
			}
								
			$body = '<!DOCTYPE html><html><head><title>&nbsp;</title><meta charset="UTF-8" /></head><body>';
			$body .= $pinctitle;

			$dom = new domDocument;
			libxml_use_internal_errors(true);
			$dom->loadHTML($response['body']);
			$dom->preserveWhiteSpace = false;
			$images = $dom->getElementsByTagName('img');

			foreach ($images as $image) {
				$prepend = '';
				if (substr($image->getAttribute('src'), 0, 2) == '//') {
					$prepend = 'http:';
				}
				$body .= '<a href="#"><img src="' . $prepend . $image->getAttribute('src') .'" /></a>';
			}

			$body .= '</body></html>';
			$body = absolute_url($body, parse_url($url, PHP_URL_SCHEME) . '://' . parse_url($url, PHP_URL_HOST));
			
			echo $body;
		} else {
			echo 'error' . __('Invalid content', 'pinc');
		}
	}
} else {
	echo 'error' . __('Invalid content', 'pinc');
}

//convert relative to absolute path for images
//ref: http://www.howtoforge.com/forums/showthread.php?t=4
function absolute_url($txt, $base_url){
  $needles = array('src="');
  $new_txt = '';
  if(substr($base_url,-1) != '/') $base_url .= '/';
  $new_base_url = $base_url;
  $base_url_parts = parse_url($base_url);

  foreach($needles as $needle){
    while($pos = strpos($txt, $needle)){
      $pos += strlen($needle);
      if(substr($txt,$pos,7) != 'http://' && substr($txt,$pos,8) != 'https://' && substr($txt,$pos,6) != 'ftp://' && substr($txt,$pos,9) != 'mailto://'){
        if(substr($txt,$pos,1) == '/') $new_base_url = $base_url_parts['scheme'].'://'.$base_url_parts['host'];
        $new_txt .= substr($txt,0,$pos).$new_base_url;
      } else {
        $new_txt .= substr($txt,0,$pos);
      }
      $txt = substr($txt,$pos);
    }
    $txt = $new_txt.$txt;
    $new_txt = '';
  }
  return $txt;
}
?>